﻿using CoreAudioApi;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace TurnOffMonitor
{
    public partial class Form1 : Form
    {
        private GlobalHotkey ghk;
        private Monitor monitor;

        public Form1()
        {
            InitializeComponent();
            this.Opacity = 0;
            this.ShowInTaskbar = false;

            NumLock.SetState(false);
            Volume.Mute(true);
            // nastavení sledování stisknutí Enteru
            ghk = new GlobalHotkey(GlobalHotkey.NOMOD, Keys.Enter, this);
            monitor = new Monitor(this);
            monitor.ActivateSleepMode(1500, 5000);

            Console.WriteLine("Press ENTER to EXIT.");
        }
        // sledování globálních kláves
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == GlobalHotkey.WM_HOTKEY_MSG_ID)
                this.Close();// zavření aplikace při stisku enteru
            base.WndProc(ref m);
        }
        // aktivace globálního sledování při načtení aplikace
        private void Form1_Load(object sender, EventArgs e)
        {
            ghk.Register();
        }
        // deaktivace globálního sledování při vypnutí aplikce
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ghk.Unregiser();
            NumLock.SetState(true);
            Volume.Mute(false);
        }
    }
}
