﻿using Microsoft.WindowsAPICodePack.ApplicationServices;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace TurnOffMonitor
{
    class Monitor
    {
        private Form form;
        private int timeOut;
        private System.Timers.Timer timer;

        public Monitor(Form form)
        {
            this.form = form;
            this.timer = new System.Timers.Timer();
            this.timer.Elapsed += timer_Elapsed;
        }

        /// <summary>
        /// Vypne monitor/y a nastaví sledování, pokud se monitor zapne např. hýnutím myši po zvoleném čase jej opět vypne
        /// </summary>
        /// <param name="startTimeOut">Čas v ms za který se monitor vypne</param>
        /// <param name="timeOut">Čas v ms za který se monitor vypne, pokud se probudí</param>
        public void ActivateSleepMode(int startTimeOut = 1500, int timeOut = 5000)
        {
            this.timeOut = timeOut;
            PowerManager.IsMonitorOnChanged += new EventHandler(MonitorOnChanged);
            TurnMonitorOff(startTimeOut);
        }

        void MonitorOnChanged(object sender, EventArgs e)
        {
            //Console.WriteLine(PowerManager.IsMonitorOn ? "On" : "Off");
            if (PowerManager.IsMonitorOn)
                TurnMonitorOff(timeOut);
        }

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int SendMessage(IntPtr hWnd, int wMsg, IntPtr wParam, IntPtr lParam);

        public void TurnMonitorOff(int waitTime = 1500)
        {
            timer.Interval = waitTime;
            timer.Start();
        }

        void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            form.Invoke(new MethodInvoker(() =>
                {
                    SendMessage(form.Handle, 0x0112, (IntPtr)0xF170, (IntPtr)2);
                }));
            timer.Stop();
        }
    }
}
