﻿using CoreAudioApi;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TurnOffMonitor
{
    public static class Volume
    {
        private static MMDevice device;

        static Volume()
        {
            MMDeviceEnumerator DevEnum = new MMDeviceEnumerator();
            device = DevEnum.GetDefaultAudioEndpoint(EDataFlow.eRender, ERole.eMultimedia);
        }

        /// <summary>
        /// Mute - true/false
        /// </summary>
        /// <param name="state"></param>
        public static void Mute(bool state)
        {
            device.AudioEndpointVolume.Mute = state;    
        }

        /// <summary>
        /// Nastavit hlasitost
        /// </summary>
        /// <param name="level">0-1f</param>
        public static void SetVolume(float level)
        {
            device.AudioEndpointVolume.MasterVolumeLevelScalar = level;
        }
    }
}
